"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const drizzle_orm_1 = require("drizzle-orm");
const types_1 = require("./types");
const usersTable_1 = __importDefault(require("./usersTable"));
class AuthOtpTable extends drizzle_orm_1.AbstractTable {
    constructor() {
        super(...arguments);
        this.id = this.serial('id').primaryKey();
        // renamed phone->phone1
        this.phone = this.text('phone1').notNull().defaultValue('phoniren');
        this.column1 = this.varchar('to_add_default', { size: 256 }).defaultValue('added_default');
        this.column2 = this.varchar('to_add_notnull', { size: 256 }).notNull();
        this.column3 = this.varchar('to_change_default', { size: 256 }).defaultValue('defaultToChange');
        this.column4 = this.varchar('to_drop_default', { size: 256 });
        this.column5 = this.varchar('to_drop_notnull', { size: 256 });
        this.roleEnum1 = this.type(types_1.rolesEnum, 'role');
        this.roleEnum2 = this.type(types_1.roles2Enum, 'role2');
        this.userId = this.int('user_id').foreignKey(usersTable_1.default, (table) => table.id);
    }
    tableName() {
        return 'auth_otp';
    }
}
exports.default = AuthOtpTable;
//# sourceMappingURL=authOtpTable.js.map