"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const drizzle_orm_1 = require("drizzle-orm");
const usersTable_1 = __importDefault(require("./usersTable"));
const types_1 = require("./types");
class CitiesTable extends drizzle_orm_1.AbstractTable {
    constructor() {
        super(...arguments);
        this.name = this.timestamp('name', { notNull: true }).defaultValue(new Date());
        this.page = this.varchar('page', { size: 256 });
        this.roleEnum = this.type(types_1.rolesEnum, 'role');
        this.userId1 = this.int('user_id').foreignKey(usersTable_1.default, (table) => table.id);
        this.data = this.jsonb('data');
    }
    tableName() {
        return 'citiess';
    }
}
exports.default = CitiesTable;
//# sourceMappingURL=cityTable.js.map