"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const drizzle_orm_1 = require("drizzle-orm");
class UsersTable extends drizzle_orm_1.AbstractTable {
    constructor() {
        super(...arguments);
        this.id = this.int('id').autoIncrement().primaryKey();
        this.phone = this.varchar('phone', { size: 256 }).unique();
        this.fullName = this.varchar('full_name', { size: 512 });
        this.test = this.decimal('test', { notNull: true, precision: 100, scale: 2 });
        this.test1 = this.bigint('test1', { notNull: true });
        this.createdAt = this.timestamp('created_at', { notNull: true });
        this.updatedAt = this.timestamp('updated_at', { notNull: true });
        this.phoneFullNameIndex = this.index([this.phone, this.fullName]);
        this.phoneIndex = this.index(this.phone);
    }
    tableName() {
        return 'users';
    }
}
exports.default = UsersTable;
//# sourceMappingURL=usersTable.js.map