"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const transpose = (matrix) => {
    let [row] = matrix;
    return row.map((value, column) => matrix.map(row => row[column]));
};
exports.default = (created, renamed, deleted) => {
    const columns = [[], [], []];
    columns[0] = created.map(({ name }) => name);
    columns[1] = renamed.map(({ from, to }) => `${from.name} -> ${to.name}`);
    columns[2] = deleted.map(({ name }) => name);
    const maxColumnLength = Math.max(columns[0].length, columns[1].length, columns[2].length);
    const filledColumns = columns.map((column) => {
        const columnLength = column.length;
        column.length = maxColumnLength;
        column.fill('', columnLength);
        return column;
    });
    return transpose(filledColumns);
};
//# sourceMappingURL=formatDataForTable.js.map